/*                                    */
/*   98 -kuha-   Ver0.1 (2005/05/08)  */
/*              (c) 2005 Akkiesoft.   */
/*                                    */
/* Stack:64k, Malloc:256k, File:0     */
/*                                    */

#include <guigui00.h>

#define	AUTO_MALLOC	0

static int MALLOC_ADDR;
#define malloc(bytes)		(void *) (MALLOC_ADDR -= ((bytes) + 7) & ~7)
#define free(addr)			for (;;); /* freeĂ͍̂ŉiv[v */

static struct LIB_TEXTBOX *textbox;

void wait(int ms, int sec)
{
	lib_waitsignaltime(0x0f, 0, 0, ms * 4294967, sec, 0);
	return;
}

void putstr(char *s, int x, int y, int l)
{
	lib_putstring1(0x1000, x, y, textbox, 15, 0, 0, l, s);
	return;
}

void OsaskMain()
{
	struct LIB_WINDOW *window;
	struct LIB_TEXTBOX *wintitle;

	char memory[][6] = { "256", "384", "512", "640", "768", "896" };
	int i = 0;

	MALLOC_ADDR = lib_readCSd(0x0010);
	lib_init(AUTO_MALLOC);

	window = lib_openwindow(AUTO_MALLOC, 0x0200, 480, 304);
	wintitle = lib_opentextbox(0x1000, AUTO_MALLOC, 0,  4, 1,  0,  0, window, 0x00c0, 0);
		lib_putstring1(0x1000, 0, 0, wintitle, 0, 0, 0, 4, "kuha");
	textbox  = lib_opentextbox(1, AUTO_MALLOC, 0, 60, 19, 0, 0, window, 0x00c0, 0);

	lib_opensoundtrack(0x0210);		// Sound track.

	wait(0, 1);

	lib_controlfreq(0x210, 0x20C49B);	// 2.4576Mhz / 0x4cd == 2001 => 2000
	wait( 50, 0);
	lib_controlfreq(0x210, 0x418937);
	wait( 50, 0);
	lib_controlfreq(0x210, 0);
	wait(250, 0);

	putstr("CPU MODE  High", 0, 0, 14);
	wait(100, 0);
	putstr("MEMORY 128KB OK", 0, 1, 15);
	wait(150, 0);

	while (i < 4) {
		putstr(memory[i], 7, 1, 3);
		wait(150, 0);
		i++;
	}

	putstr( "+  128 KB OK", 13, 1, 13);
	wait(75, 0);

	i = 0;
	while (i < 6) {
		putstr(memory[i], 16, 1, 3);
		wait(75, 0);
		i++;
	}
	putstr("1024", 15, 1, 4);
	wait(0, 2);

	putstr("How many files(0-15)?", 0, 0, 21);
	putstr("                         ", 0, 1, 25);
	wait(0, 2);

	putstr("NEC N-88 BASIC(86) version 2.0", 0, 1, 30);
	putstr("Copyright (C) 1983 by NEC Corporation / Microsoft Corp.", 0, 2, 55);
	putstr("641668 Bytes free", 0, 3, 17);
	putstr("Ok", 0, 4, 2);

	lib_waitsignal(0x0001, 0, 0);
}
